VTK: vtkHandleRepresentation Class Reference

| VTK 9.0.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkHandleRepresentation Class Reference

abstract class for representing widget handles More...

`#include <vtkHandleRepresentation.h>`

Inheritance diagram for vtkHandleRepresentation:
[legend]
Collaboration diagram for vtkHandleRepresentation:
[legend]

## Public Types
enum | _InteractionState { Outside = 0, Nearby, Selecting, Translating, Scaling }
typedef vtkWidgetRepresentation | Superclass
| Standard methods for instances of this class. More...
Public Types inherited from vtkWidgetRepresentation
enum | Axis { NONE = -1, XAxis = 0, YAxis = 1, ZAxis = 2 }
| Axis labels. More...
typedef vtkProp | Superclass
| Standard methods for instances of this class. More...
Public Types inherited from vtkProp
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkHandleRepresentation * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | SetDisplayPosition (double pos[3])
| Handles usually have their coordinates set in display coordinates (generally by an associated widget) and internally maintain the position in world coordinates. More...
virtual void | GetDisplayPosition (double pos[3])
virtual double * | GetDisplayPosition ()
virtual void | SetWorldPosition (double pos[3])
virtual void | GetWorldPosition (double pos[3])
virtual double * | GetWorldPosition ()
virtual void | SetTolerance (int)
| The tolerance representing the distance to the widget (in pixels) in which the cursor is considered near enough to the widget to be active. More...
virtual int | GetTolerance ()
virtual void | SetActiveRepresentation (vtkTypeBool)
| Flag controls whether the widget becomes visible when the mouse pointer moves close to it (i.e., the widget becomes active). More...
virtual vtkTypeBool | GetActiveRepresentation ()
virtual void | ActiveRepresentationOn ()
virtual void | ActiveRepresentationOff ()
virtual void | SetInteractionState (int)
| The interaction state may be set from a widget (e.g., HandleWidget) or other object. More...
virtual void | SetConstrained (vtkTypeBool)
| Specify whether any motions (such as scale, translate, etc.) are constrained in some way (along an axis, etc.) Widgets can use this to control the resulting motion. More...
virtual vtkTypeBool | GetConstrained ()
virtual void | ConstrainedOn ()
virtual void | ConstrainedOff ()
virtual int | CheckConstraint (vtkRenderer *renderer, double pos[2])
| Method has to be overridden in the subclasses which has constraints on placing the handle (Ex. More...
void | ShallowCopy (vtkProp *prop) override
| Methods to make this class properly act like a vtkWidgetRepresentation. More...
virtual void | DeepCopy (vtkProp *prop)
void | SetRenderer (vtkRenderer *ren) override
| Subclasses of vtkWidgetRepresentation must implement these methods. More...
vtkMTimeType | GetMTime () override
| Overload the superclasses' GetMTime() because the internal vtkCoordinates are used to keep the state of the representation. More...
virtual void | SetPointPlacer (vtkPointPlacer *)
| Set/Get the point placer. More...
virtual vtkPointPlacer * | GetPointPlacer ()
virtual void | GetTranslationVector (const double *p1, const double *p2, double *v) const
| Gets the translation vector. More...
virtual void | Translate (const double *p1, const double *p2)
| Translates world position by vector p1p2 projected on the constraint axis if any. More...
virtual void | Translate (const double *v)
| Translates world position by vector v projected on the constraint axis if any. More...
virtual int | GetTranslationAxis ()
| Gets/Sets the constraint axis for translations. More...
virtual void | SetTranslationAxis (int)
void | SetXTranslationAxisOn ()
| Toggles constraint translation axis on/off. More...
void | SetYTranslationAxisOn ()
void | SetZTranslationAxisOn ()
void | SetTranslationAxisOff ()
bool | IsTranslationConstrained ()
| Returns true if ContrainedAxis. More...
Public Member Functions inherited from vtkWidgetRepresentation
vtkWidgetRepresentation * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PickingManagedOn ()
| Enable/Disable the use of a manager to process the picking. More...
virtual void | PickingManagedOff ()
void | SetPickingManaged (bool managed)
virtual bool | GetPickingManaged ()
virtual vtkRenderer * | GetRenderer ()
virtual void | BuildRepresentation ()=0
virtual void | PlaceWidget (double *vtkNotUsed(bounds[6]))
| The following is a suggested API for widget representations. More...
virtual void | StartWidgetInteraction (double eventPos[2])
virtual void | WidgetInteraction (double newEventPos[2])
virtual void | EndWidgetInteraction (double newEventPos[2])
virtual int | ComputeInteractionState (int X, int Y, int modify=0)
virtual int | GetInteractionState ()
virtual void | Highlight (int vtkNotUsed(highlightOn))
virtual void | StartComplexInteraction (vtkRenderWindowInteractor *, vtkAbstractWidget *, unsigned long, void *)
virtual void | ComplexInteraction (vtkRenderWindowInteractor *, vtkAbstractWidget *, unsigned long, void *)
virtual void | EndComplexInteraction (vtkRenderWindowInteractor *, vtkAbstractWidget *, unsigned long, void *)
virtual int | ComputeComplexInteractionState (vtkRenderWindowInteractor *iren, vtkAbstractWidget *widget, unsigned long event, void *callData, int modify=0)
virtual void | SetPlaceFactor (double)
| Set/Get a factor representing the scaling of the widget upon placement (via the PlaceWidget() method). More...
virtual double | GetPlaceFactor ()
virtual void | SetHandleSize (double)
| Set/Get the factor that controls the size of the handles that appear as part of the widget (if any). More...
virtual double | GetHandleSize ()
virtual vtkTypeBool | GetNeedToRender ()
| Some subclasses use this data member to keep track of whether to render or not (i.e., to minimize the total number of renders). More...
virtual void | SetNeedToRender (vtkTypeBool)
virtual void | NeedToRenderOn ()
virtual void | NeedToRenderOff ()
double * | GetBounds () override
| Methods to make this class behave as a vtkProp. More...
void | ShallowCopy (vtkProp *prop) override
| Shallow copy of this vtkProp. More...
void | GetActors (vtkPropCollection *) override
| For some exporters and other other operations we must be able to collect all the actors or volumes. More...
void | GetActors2D (vtkPropCollection *) override
void | GetVolumes (vtkPropCollection *) override
void | ReleaseGraphicsResources (vtkWindow *) override
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE Release any graphics resources that are being consumed by this actor. More...
int | RenderOverlay (vtkViewport *vtkNotUsed(viewport)) override
int | RenderOpaqueGeometry (vtkViewport *vtkNotUsed(viewport)) override
int | RenderTranslucentPolygonalGeometry (vtkViewport *vtkNotUsed(viewport)) override
int | RenderVolumetricGeometry (vtkViewport *vtkNotUsed(viewport)) override
vtkTypeBool | HasTranslucentPolygonalGeometry () override
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THESE METHODS OUTSIDE OF THE RENDERING PROCESS Does this prop have some translucent polygonal geometry? This method is called during the rendering process to know if there is some translucent polygonal geometry. More...
virtual void | RegisterPickers ()
| Register internal Pickers in the Picking Manager. More...
virtual void | UnRegisterPickers ()
| Unregister internal pickers from the Picking Manager. More...
Public Member Functions inherited from vtkProp
vtkProp * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | SetVisibility (vtkTypeBool)
| Set/Get visibility of this vtkProp. More...
virtual vtkTypeBool | GetVisibility ()
virtual void | VisibilityOn ()
virtual void | VisibilityOff ()
virtual void | SetPickable (vtkTypeBool)
| Set/Get the pickable instance variable. More...
virtual vtkTypeBool | GetPickable ()
virtual void | PickableOn ()
virtual void | PickableOff ()
virtual void | Pick ()
| Method fires PickEvent if the prop is picked. More...
virtual void | SetDragable (vtkTypeBool)
| Set/Get the value of the dragable instance variable. More...
virtual vtkTypeBool | GetDragable ()
virtual void | DragableOn ()
virtual void | DragableOff ()
virtual vtkMTimeType | GetRedrawMTime ()
| Return the mtime of anything that would cause the rendered image to appear differently. More...
virtual void | SetUseBounds (bool)
| In case the Visibility flag is true, tell if the bounds of this prop should be taken into account or ignored during the computation of other bounding boxes, like in vtkRenderer::ResetCamera(). More...
virtual bool | GetUseBounds ()
virtual void | UseBoundsOn ()
virtual void | UseBoundsOff ()
virtual void | InitPathTraversal ()
| vtkProp and its subclasses can be picked by subclasses of vtkAbstractPicker (e.g., vtkPropPicker). More...
virtual vtkAssemblyPath * | GetNextPath ()
virtual int | GetNumberOfPaths ()
virtual void | PokeMatrix (vtkMatrix4x4 *vtkNotUsed(matrix))
| These methods are used by subclasses to place a matrix (if any) in the prop prior to rendering. More...
virtual vtkMatrix4x4 * | GetMatrix ()
virtual vtkInformation * | GetPropertyKeys ()
| Set/Get property keys. More...
virtual void | SetPropertyKeys (vtkInformation *keys)
virtual bool | HasKeys (vtkInformation *requiredKeys)
| Tells if the prop has all the required keys. More...
virtual int | RenderOpaqueGeometry (vtkViewport *)
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THESE METHODS OUTSIDE OF THE RENDERING PROCESS All concrete subclasses must be able to render themselves. More...
virtual int | RenderTranslucentPolygonalGeometry (vtkViewport *)
virtual int | RenderVolumetricGeometry (vtkViewport *)
virtual int | RenderOverlay (vtkViewport *)
virtual bool | RenderFilteredOpaqueGeometry (vtkViewport *v, vtkInformation *requiredKeys)
| Render the opaque geometry only if the prop has all the requiredKeys. More...
virtual bool | RenderFilteredTranslucentPolygonalGeometry (vtkViewport *v, vtkInformation *requiredKeys)
| Render the translucent polygonal geometry only if the prop has all the requiredKeys. More...
virtual bool | RenderFilteredVolumetricGeometry (vtkViewport *v, vtkInformation *requiredKeys)
| Render the volumetric geometry only if the prop has all the requiredKeys. More...
virtual bool | RenderFilteredOverlay (vtkViewport *v, vtkInformation *requiredKeys)
| Render in the overlay of the viewport only if the prop has all the requiredKeys. More...
virtual vtkTypeBool | HasOpaqueGeometry ()
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THESE METHODS OUTSIDE OF THE RENDERING PROCESS Does this prop have some opaque geometry? This method is called during the rendering process to know if there is some opaque geometry. More...
virtual double | GetEstimatedRenderTime (vtkViewport *)
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THESE METHODS OUTSIDE OF THE RENDERING PROCESS The EstimatedRenderTime may be used to select between different props, for example in LODProp it is used to select the level-of-detail. More...
virtual double | GetEstimatedRenderTime ()
virtual void | SetEstimatedRenderTime (double t)
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THESE METHODS OUTSIDE OF THE RENDERING PROCESS This method is used by, for example, the vtkLODProp3D in order to initialize the estimated render time at start-up to some user defined value. More...
virtual void | RestoreEstimatedRenderTime ()
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THESE METHODS OUTSIDE OF THE RENDERING PROCESS When the EstimatedRenderTime is first set to 0.0 (in the SetAllocatedRenderTime method) the old value is saved. More...
virtual void | AddEstimatedRenderTime (double t, vtkViewport *vtkNotUsed(vp))
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THIS METHOD OUTSIDE OF THE RENDERING PROCESS This method is intended to allow the renderer to add to the EstimatedRenderTime in props that require information that the renderer has in order to do this. More...
virtual void | SetAllocatedRenderTime (double t, vtkViewport *vtkNotUsed(v))
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THIS METHOD OUTSIDE OF THE RENDERING PROCESS The renderer may use the allocated rendering time to determine how to render this actor. More...
virtual double | GetAllocatedRenderTime ()
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THIS METHOD OUTSIDE OF THE RENDERING PROCESS. More...
void | SetRenderTimeMultiplier (double t)
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THIS METHOD OUTSIDE OF THE RENDERING PROCESS Get/Set the multiplier for the render time. More...
virtual double | GetRenderTimeMultiplier ()
virtual void | BuildPaths (vtkAssemblyPaths *paths, vtkAssemblyPath *path)
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THIS METHOD OUTSIDE OF THE RENDERING PROCESS Used to construct assembly paths and perform part traversal. More...
virtual bool | GetSupportsSelection ()
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THIS METHOD OUTSIDE OF THE RENDERING PROCESS Used by vtkHardwareSelector to determine if the prop supports hardware selection. More...
virtual void | ProcessSelectorPixelBuffers (vtkHardwareSelector *, std::vector< unsigned int > &)
| allows a prop to update a selections color buffers More...
virtual int | GetNumberOfConsumers ()
| Get the number of consumers. More...
void | AddConsumer (vtkObject *c)
| Add or remove or get or check a consumer,. More...
void | RemoveConsumer (vtkObject *c)
vtkObject * | GetConsumer (int i)
int | IsConsumer (vtkObject *c)
virtual void | SetShaderProperty (vtkShaderProperty *property)
| Set/Get the shader property. More...
virtual vtkShaderProperty * | GetShaderProperty ()
virtual bool | IsRenderingTranslucentPolygonalGeometry ()
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
vtkCommand * | GetCommand (unsigned long tag)
void | RemoveObserver (vtkCommand *)
void | RemoveObservers (unsigned long event, vtkCommand *)
void | RemoveObservers (const char *event, vtkCommand *)
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
int | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
int | InvokeEvent (const char *event, void *callData)
int | InvokeEvent (unsigned long event)
int | InvokeEvent (const char *event)
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
void | PrintRevisions (ostream &)
| Legacy. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkHandleRepresentation * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkWidgetRepresentation
static vtkTypeBool | IsTypeOf (const char *type)
static vtkWidgetRepresentation * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkProp
static vtkTypeBool | IsTypeOf (const char *type)
static vtkProp * | SafeDownCast (vtkObjectBase *o)
static vtkInformationIntegerKey * | GeneralTextureUnit ()
| Optional Key Indicating the texture unit for general texture mapping Old OpenGL was a state machine where you would push or pop items. More...
static vtkInformationDoubleVectorKey * | GeneralTextureTransform ()
| Optional Key Indicating the texture transform for general texture mapping Old OpenGL was a state machine where you would push or pop items. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (int val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
static void | GlobalWarningDisplayOff ()
static int | GetGlobalWarningDisplay ()
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkHandleRepresentation ()
| ~vtkHandleRepresentation () override
Protected Member Functions inherited from vtkWidgetRepresentation
| vtkWidgetRepresentation ()
| ~vtkWidgetRepresentation () override
void | AdjustBounds (double bounds[6], double newBounds[6], double center[3])
vtkPickingManager * | GetPickingManager ()
| Return the picking manager associated on the context on which the widget representation currently belong. More...
vtkAssemblyPath * | GetAssemblyPath (double X, double Y, double Z, vtkAbstractPropPicker *picker)
| Proceed to a pick, whether through the PickingManager if the picking is managed or directly using the registered picker, and return the assembly path. More...
vtkAssemblyPath * | GetAssemblyPath3DPoint (double pos[3], vtkAbstractPropPicker *picker)
bool | NearbyEvent (int X, int Y, double bounds[6])
double | SizeHandlesRelativeToViewport (double factor, double pos[3])
double | SizeHandlesInPixels (double factor, double pos[3])
void | UpdatePropPose (vtkProp3D *prop, const double *pos1, const double *orient1, const double *pos2, const double *orient2)
Protected Member Functions inherited from vtkProp
| vtkProp ()
| ~vtkProp () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | CollectRevisions (ostream &)
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
int | Tolerance
vtkTypeBool | ActiveRepresentation
vtkTypeBool | Constrained
vtkCoordinate * | DisplayPosition
vtkCoordinate * | WorldPosition
vtkTimeStamp | DisplayPositionTime
vtkTimeStamp | WorldPositionTime
vtkPointPlacer * | PointPlacer
int | TranslationAxis
Protected Attributes inherited from vtkWidgetRepresentation
vtkWeakPointer< vtkRenderer > | Renderer
int | InteractionState
double | StartEventPosition [3]
double | PlaceFactor
int | Placed
double | InitialBounds [6]
double | InitialLength
int | ValidPick
bool | PickingManaged
double | HandleSize
vtkTypeBool | NeedToRender
vtkTimeStamp | BuildTime
vtkNew< vtkTransform > | TempTransform
vtkNew< vtkMatrix4x4 > | TempMatrix
Protected Attributes inherited from vtkProp
vtkTypeBool | Visibility
vtkTypeBool | Pickable
vtkTypeBool | Dragable
bool | UseBounds
double | AllocatedRenderTime
double | EstimatedRenderTime
double | SavedEstimatedRenderTime
double | RenderTimeMultiplier
int | NumberOfConsumers
vtkObject ** | Consumers
vtkAssemblyPaths * | Paths
vtkInformation * | PropertyKeys
vtkShaderProperty * | ShaderProperty
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

abstract class for representing widget handles

This class defines an API for widget handle representations. These representations interact with vtkHandleWidget. Various representations can be used depending on the nature of the handle. The basic functionality of the handle representation is to maintain a position. The position is represented via a vtkCoordinate, meaning that the position can be easily obtained in a variety of coordinate systems.

Optional features for this representation include an active mode (the widget appears only when the mouse pointer is close to it). The active distance is expressed in pixels and represents a circle in display space.

The class may be subclassed so that alternative representations can be created. The class defines an API and a default implementation that the vtkHandleWidget interacts with to render itself in the scene.

Warning
  The separation of the widget event handling and representation enables users and developers to create new appearances for the widget. It also facilitates parallel processing, where the client application handles events, and remote representations of the widget are slaves to the client (and do not handle events).

See also
  vtkRectilinearWipeWidget vtkWidgetRepresentation vtkAbstractWidget

Definition at line 55 of file vtkHandleRepresentation.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkWidgetRepresentation vtkHandleRepresentation::Superclass

Standard methods for instances of this class.

Definition at line 62 of file vtkHandleRepresentation.h.

## Member Enumeration Documentation

## ◆ _InteractionState

enum vtkHandleRepresentation::_InteractionState

Enumerator
Outside |
Nearby |
Selecting |
Translating |
Scaling |

Definition at line 108 of file vtkHandleRepresentation.h.

## Constructor & Destructor Documentation

## ◆ vtkHandleRepresentation()

vtkHandleRepresentation::vtkHandleRepresentation | ( |  | ) |
| protected

## ◆ ~vtkHandleRepresentation()

vtkHandleRepresentation::~vtkHandleRepresentation | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkHandleRepresentation::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkHandleRepresentation::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkWidgetRepresentation.

Reimplemented in vtkConstrainedPointHandleRepresentation, vtkAbstractPolygonalHandleRepresentation3D, vtkFixedSizeHandleRepresentation3D, vtkPointHandleRepresentation2D, vtkMeasurementCubeHandleRepresentation3D, vtkOrientedPolygonalHandleRepresentation3D, vtkPointHandleRepresentation3D, vtkSphereHandleRepresentation, and vtkPolygonalHandleRepresentation3D.

## ◆ SafeDownCast()

static vtkHandleRepresentation* vtkHandleRepresentation::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkHandleRepresentation::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkWidgetRepresentation.

Reimplemented in vtkConstrainedPointHandleRepresentation, vtkAbstractPolygonalHandleRepresentation3D, vtkFixedSizeHandleRepresentation3D, vtkPointHandleRepresentation2D, vtkMeasurementCubeHandleRepresentation3D, vtkOrientedPolygonalHandleRepresentation3D, vtkPointHandleRepresentation3D, vtkSphereHandleRepresentation, and vtkPolygonalHandleRepresentation3D.

## ◆ NewInstance()

vtkHandleRepresentation* vtkHandleRepresentation::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkHandleRepresentation::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

Reimplemented in vtkPointHandleRepresentation2D, vtkMeasurementCubeHandleRepresentation3D, vtkOrientedPolygonalHandleRepresentation3D, vtkPointHandleRepresentation3D, vtkSphereHandleRepresentation, and vtkPolygonalHandleRepresentation3D.

## ◆ SetDisplayPosition()

virtual void vtkHandleRepresentation::SetDisplayPosition | ( | double | pos[3] | ) |
| virtual

Handles usually have their coordinates set in display coordinates (generally by an associated widget) and internally maintain the position in world coordinates.

(Using world coordinates insures that handles are rendered in the right position when the camera view changes.) These methods are often subclassed because special constraint operations can be used to control the actual positioning.

Reimplemented in vtkPointHandleRepresentation2D, vtkConstrainedPointHandleRepresentation, vtkAbstractPolygonalHandleRepresentation3D, vtkPointHandleRepresentation3D, vtkSphereHandleRepresentation, and vtkMeasurementCubeHandleRepresentation3D.

## ◆ GetDisplayPosition() [1/2]

virtual void vtkHandleRepresentation::GetDisplayPosition | ( | double | pos[3] | ) |
| virtual

## ◆ GetDisplayPosition() [2/2]

virtual double* vtkHandleRepresentation::GetDisplayPosition | ( |  | ) |
| virtual

## ◆ SetWorldPosition()

virtual void vtkHandleRepresentation::SetWorldPosition | ( | double | pos[3] | ) |
| virtual

Reimplemented in vtkAbstractPolygonalHandleRepresentation3D, vtkPointHandleRepresentation3D, vtkSphereHandleRepresentation, vtkMeasurementCubeHandleRepresentation3D, and vtkPolygonalHandleRepresentation3D.

## ◆ GetWorldPosition() [1/2]

virtual void vtkHandleRepresentation::GetWorldPosition | ( | double | pos[3] | ) |
| virtual

## ◆ GetWorldPosition() [2/2]

virtual double* vtkHandleRepresentation::GetWorldPosition | ( |  | ) |
| virtual

## ◆ SetTolerance()

virtual void vtkHandleRepresentation::SetTolerance | ( | int |  | ) |
| virtual

The tolerance representing the distance to the widget (in pixels) in which the cursor is considered near enough to the widget to be active.

## ◆ GetTolerance()

virtual int vtkHandleRepresentation::GetTolerance | ( |  | ) |
| virtual

## ◆ SetActiveRepresentation()

virtual void vtkHandleRepresentation::SetActiveRepresentation | ( | vtkTypeBool |  | ) |
| virtual

Flag controls whether the widget becomes visible when the mouse pointer moves close to it (i.e., the widget becomes active).

By default, ActiveRepresentation is off and the representation is always visible.

## ◆ GetActiveRepresentation()

virtual vtkTypeBool vtkHandleRepresentation::GetActiveRepresentation | ( |  | ) |
| virtual

## ◆ ActiveRepresentationOn()

virtual void vtkHandleRepresentation::ActiveRepresentationOn | ( |  | ) |
| virtual

## ◆ ActiveRepresentationOff()

virtual void vtkHandleRepresentation::ActiveRepresentationOff | ( |  | ) |
| virtual

## ◆ SetInteractionState()

virtual void vtkHandleRepresentation::SetInteractionState | ( | int |  | ) |
| virtual

The interaction state may be set from a widget (e.g., HandleWidget) or other object.

This controls how the interaction with the widget proceeds. Normally this method is used as part of a handshaking processwith the widget: First ComputeInteractionState() is invoked that returns a state based on geometric considerations (i.e., cursor near a widget feature), then based on events, the widget may modify this further.

## ◆ SetConstrained()

virtual void vtkHandleRepresentation::SetConstrained | ( | vtkTypeBool |  | ) |
| virtual

Specify whether any motions (such as scale, translate, etc.) are constrained in some way (along an axis, etc.) Widgets can use this to control the resulting motion.

## ◆ GetConstrained()

virtual vtkTypeBool vtkHandleRepresentation::GetConstrained | ( |  | ) |
| virtual

## ◆ ConstrainedOn()

virtual void vtkHandleRepresentation::ConstrainedOn | ( |  | ) |
| virtual

## ◆ ConstrainedOff()

virtual void vtkHandleRepresentation::ConstrainedOff | ( |  | ) |
| virtual

## ◆ CheckConstraint()

virtual int vtkHandleRepresentation::CheckConstraint | ( | vtkRenderer * | renderer,
|  | double | pos[2]
| ) |  |
| virtual

Method has to be overridden in the subclasses which has constraints on placing the handle (Ex.

vtkConstrainedPointHandleRepresentation). It should return 1 if the position is within the constraint, else it should return 0. By default it returns 1.

Reimplemented in vtkConstrainedPointHandleRepresentation.

## ◆ ShallowCopy()

void vtkHandleRepresentation::ShallowCopy | ( | vtkProp * | prop | ) |
| overridevirtual

Methods to make this class properly act like a vtkWidgetRepresentation.

Reimplemented from vtkProp.

Reimplemented in vtkPointHandleRepresentation3D, vtkSphereHandleRepresentation, vtkPointHandleRepresentation2D, and vtkMeasurementCubeHandleRepresentation3D.

## ◆ DeepCopy()

virtual void vtkHandleRepresentation::DeepCopy | ( | vtkProp * | prop | ) |
| virtual

Reimplemented in vtkPointHandleRepresentation3D, vtkSphereHandleRepresentation, vtkAbstractPolygonalHandleRepresentation3D, vtkPointHandleRepresentation2D, and vtkMeasurementCubeHandleRepresentation3D.

## ◆ SetRenderer()

void vtkHandleRepresentation::SetRenderer | ( | vtkRenderer * | ren | ) |
| overridevirtual

Subclasses of vtkWidgetRepresentation must implement these methods.

This is considered the minimum API for a widget representation.

    SetRenderer() - the renderer in which the representations draws itself.
    Typically the renderer is set by the associated widget.
    Use the widget's SetCurrentRenderer() method in most cases;
    otherwise there is a risk of inconsistent behavior as events
    and drawing may be performed in different viewports.
    BuildRepresentation() - update the geometry of the widget based on its
    current state.

WARNING: The renderer is NOT reference counted by the representation, in order to avoid reference loops. Be sure that the representation lifetime does not extend beyond the renderer lifetime.

Reimplemented from vtkWidgetRepresentation.

## ◆ GetMTime()

vtkMTimeType vtkHandleRepresentation::GetMTime | ( |  | ) |
| overridevirtual

Overload the superclasses' GetMTime() because the internal vtkCoordinates are used to keep the state of the representation.

Reimplemented from vtkObject.

## ◆ SetPointPlacer()

virtual void vtkHandleRepresentation::SetPointPlacer | ( | vtkPointPlacer * |  | ) |
| virtual

Set/Get the point placer.

Point placers can be used to dictate constraints on the placement of handles. As an example, see vtkBoundedPlanePointPlacer (constrains the placement of handles to a set of bounded planes) vtkFocalPlanePointPlacer (constrains placement on the focal plane) etc. The default point placer is vtkPointPlacer (which does not apply any constraints, so the handles are free to move anywhere).

Reimplemented in vtkPointHandleRepresentation2D.

## ◆ GetPointPlacer()

virtual vtkPointPlacer* vtkHandleRepresentation::GetPointPlacer | ( |  | ) |
| virtual

## ◆ GetTranslationVector()

virtual void vtkHandleRepresentation::GetTranslationVector | ( | const double * | p1,
|  | const double * | p2,
|  | double * | v
| ) |  | const
| virtual

Gets the translation vector.

## ◆ Translate() [1/2]

virtual void vtkHandleRepresentation::Translate | ( | const double * | p1,
|  | const double * | p2
| ) |  |
| virtual

Translates world position by vector p1p2 projected on the constraint axis if any.

Reimplemented in vtkPointHandleRepresentation3D, vtkAbstractPolygonalHandleRepresentation3D, and vtkSphereHandleRepresentation.

## ◆ Translate() [2/2]

virtual void vtkHandleRepresentation::Translate | ( | const double * | v | ) |
| virtual

Translates world position by vector v projected on the constraint axis if any.

Reimplemented in vtkConstrainedPointHandleRepresentation, and vtkPointHandleRepresentation2D.

## ◆ GetTranslationAxis()

virtual int vtkHandleRepresentation::GetTranslationAxis | ( |  | ) |
| virtual

Gets/Sets the constraint axis for translations.

Returns Axis::NONE if none.

## ◆ SetTranslationAxis()

virtual void vtkHandleRepresentation::SetTranslationAxis | ( | int |  | ) |
| virtual

## ◆ SetXTranslationAxisOn()

void vtkHandleRepresentation::SetXTranslationAxisOn | ( |  | ) |
| inline

Toggles constraint translation axis on/off.

Definition at line 211 of file vtkHandleRepresentation.h.

## ◆ SetYTranslationAxisOn()

void vtkHandleRepresentation::SetYTranslationAxisOn | ( |  | ) |
| inline

Definition at line 212 of file vtkHandleRepresentation.h.

## ◆ SetZTranslationAxisOn()

void vtkHandleRepresentation::SetZTranslationAxisOn | ( |  | ) |
| inline

Definition at line 213 of file vtkHandleRepresentation.h.

## ◆ SetTranslationAxisOff()

void vtkHandleRepresentation::SetTranslationAxisOff | ( |  | ) |
| inline

Definition at line 214 of file vtkHandleRepresentation.h.

## ◆ IsTranslationConstrained()

bool vtkHandleRepresentation::IsTranslationConstrained | ( |  | ) |
| inline

Returns true if ContrainedAxis.

Definition at line 221 of file vtkHandleRepresentation.h.

## Member Data Documentation

## ◆ Tolerance

int vtkHandleRepresentation::Tolerance
| protected

Definition at line 228 of file vtkHandleRepresentation.h.

## ◆ ActiveRepresentation

vtkTypeBool vtkHandleRepresentation::ActiveRepresentation
| protected

Definition at line 229 of file vtkHandleRepresentation.h.

## ◆ Constrained

vtkTypeBool vtkHandleRepresentation::Constrained
| protected

Definition at line 230 of file vtkHandleRepresentation.h.

## ◆ DisplayPosition

vtkCoordinate* vtkHandleRepresentation::DisplayPosition
| protected

Definition at line 236 of file vtkHandleRepresentation.h.

## ◆ WorldPosition

vtkCoordinate* vtkHandleRepresentation::WorldPosition
| protected

Definition at line 237 of file vtkHandleRepresentation.h.

## ◆ DisplayPositionTime

vtkTimeStamp vtkHandleRepresentation::DisplayPositionTime
| protected

Definition at line 240 of file vtkHandleRepresentation.h.

## ◆ WorldPositionTime

vtkTimeStamp vtkHandleRepresentation::WorldPositionTime
| protected

Definition at line 241 of file vtkHandleRepresentation.h.

## ◆ PointPlacer

vtkPointPlacer* vtkHandleRepresentation::PointPlacer
| protected

Definition at line 244 of file vtkHandleRepresentation.h.

## ◆ TranslationAxis

int vtkHandleRepresentation::TranslationAxis
| protected

Definition at line 247 of file vtkHandleRepresentation.h.

The documentation for this class was generated from the following file:

- Interaction/Widgets/vtkHandleRepresentation.h